"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import luminarycloud._proto.api.v0.luminarycloud.common.common_pb2
import luminarycloud._proto.upload.upload_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class Mesh(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _MeshStatus:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _MeshStatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[Mesh._MeshStatus.ValueType], builtins.type):  # noqa: F821
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        MESH_STATUS_UNSPECIFIED: Mesh._MeshStatus.ValueType  # 0
        """A well-formed mesh resource will never have this value."""
        MESH_STATUS_CREATING: Mesh._MeshStatus.ValueType  # 1
        """Mesh is being created."""
        MESH_STATUS_COMPLETED: Mesh._MeshStatus.ValueType  # 2
        """Mesh was created successfully and can be used to create simulations."""
        MESH_STATUS_FAILED: Mesh._MeshStatus.ValueType  # 3
        """Mesh was not created successfully and is unusable."""

    class MeshStatus(_MeshStatus, metaclass=_MeshStatusEnumTypeWrapper): ...
    MESH_STATUS_UNSPECIFIED: Mesh.MeshStatus.ValueType  # 0
    """A well-formed mesh resource will never have this value."""
    MESH_STATUS_CREATING: Mesh.MeshStatus.ValueType  # 1
    """Mesh is being created."""
    MESH_STATUS_COMPLETED: Mesh.MeshStatus.ValueType  # 2
    """Mesh was created successfully and can be used to create simulations."""
    MESH_STATUS_FAILED: Mesh.MeshStatus.ValueType  # 3
    """Mesh was not created successfully and is unusable."""

    ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    CREATE_TIME_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    id: builtins.str
    """The unique identifier for the mesh."""
    name: builtins.str
    """User specified mesh name, does not need to be unique. Maximum
    allowed length is 256 characters.
    """
    @property
    def create_time(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Output only. The timestamp when the mesh was created."""
    status: global___Mesh.MeshStatus.ValueType
    """Output only. The current status of the mesh."""
    def __init__(
        self,
        *,
        id: builtins.str = ...,
        name: builtins.str = ...,
        create_time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        status: global___Mesh.MeshStatus.ValueType = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["create_time", b"create_time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["create_time", b"create_time", "id", b"id", "name", b"name", "status", b"status"]) -> None: ...

global___Mesh = Mesh

class GetMeshRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    id: builtins.str
    """Required. Identifies the mesh to retrieve."""
    def __init__(
        self,
        *,
        id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["id", b"id"]) -> None: ...

global___GetMeshRequest = GetMeshRequest

class GetMeshResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MESH_FIELD_NUMBER: builtins.int
    @property
    def mesh(self) -> global___Mesh:
        """The requested mesh."""
    def __init__(
        self,
        *,
        mesh: global___Mesh | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["mesh", b"mesh"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["mesh", b"mesh"]) -> None: ...

global___GetMeshResponse = GetMeshResponse

class GetMeshMetadataRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    id: builtins.str
    """Required. Identifies the mesh to retrieve."""
    def __init__(
        self,
        *,
        id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["id", b"id"]) -> None: ...

global___GetMeshMetadataRequest = GetMeshMetadataRequest

class GetMeshMetadataResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MESH_METADATA_FIELD_NUMBER: builtins.int
    @property
    def mesh_metadata(self) -> global___MeshMetadata:
        """The requested mesh metadata."""
    def __init__(
        self,
        *,
        mesh_metadata: global___MeshMetadata | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["mesh_metadata", b"mesh_metadata"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["mesh_metadata", b"mesh_metadata"]) -> None: ...

global___GetMeshMetadataResponse = GetMeshMetadataResponse

class MeshMetadata(google.protobuf.message.Message):
    """Mesh metadata includes the basic mesh statistics and details, including
    mesh zones, zone boundaries, mesh statistics, etc.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class MeshStats(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        N_POINTS_FIELD_NUMBER: builtins.int
        N_FACES_FIELD_NUMBER: builtins.int
        N_CVS_FIELD_NUMBER: builtins.int
        MIN_COORD_FIELD_NUMBER: builtins.int
        MAX_COORD_FIELD_NUMBER: builtins.int
        n_points: builtins.int
        """Number of points."""
        n_faces: builtins.int
        """Number of faces."""
        n_cvs: builtins.int
        """Number of cvs."""
        @property
        def min_coord(self) -> luminarycloud._proto.api.v0.luminarycloud.common.common_pb2.Vector3:
            """Min coordinate in the mesh."""
        @property
        def max_coord(self) -> luminarycloud._proto.api.v0.luminarycloud.common.common_pb2.Vector3:
            """Max coordinate in the mesh."""
        def __init__(
            self,
            *,
            n_points: builtins.int = ...,
            n_faces: builtins.int = ...,
            n_cvs: builtins.int = ...,
            min_coord: luminarycloud._proto.api.v0.luminarycloud.common.common_pb2.Vector3 | None = ...,
            max_coord: luminarycloud._proto.api.v0.luminarycloud.common.common_pb2.Vector3 | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing_extensions.Literal["max_coord", b"max_coord", "min_coord", b"min_coord"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing_extensions.Literal["max_coord", b"max_coord", "min_coord", b"min_coord", "n_cvs", b"n_cvs", "n_faces", b"n_faces", "n_points", b"n_points"]) -> None: ...

    class Boundary(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        NAME_FIELD_NUMBER: builtins.int
        STATS_FIELD_NUMBER: builtins.int
        name: builtins.str
        """Dataset name prefix of this zone. E.g.: "0/bound/airfoil",
        "1/bound/farfield",
        ...
        """
        @property
        def stats(self) -> global___MeshMetadata.MeshStats:
            """Mesh statistics of the boundary."""
        def __init__(
            self,
            *,
            name: builtins.str = ...,
            stats: global___MeshMetadata.MeshStats | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing_extensions.Literal["stats", b"stats"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing_extensions.Literal["name", b"name", "stats", b"stats"]) -> None: ...

    class Zone(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        BOUNDARIES_FIELD_NUMBER: builtins.int
        STATS_FIELD_NUMBER: builtins.int
        NAME_FIELD_NUMBER: builtins.int
        @property
        def boundaries(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___MeshMetadata.Boundary]:
            """Per-boundary metadata"""
        @property
        def stats(self) -> global___MeshMetadata.MeshStats:
            """Mesh statistics of the zone."""
        name: builtins.str
        """The zone/volume name if it could be inferred from the mesh conversion
        or mesh generation processes. This field may be empty.
        """
        def __init__(
            self,
            *,
            boundaries: collections.abc.Iterable[global___MeshMetadata.Boundary] | None = ...,
            stats: global___MeshMetadata.MeshStats | None = ...,
            name: builtins.str = ...,
        ) -> None: ...
        def HasField(self, field_name: typing_extensions.Literal["stats", b"stats"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing_extensions.Literal["boundaries", b"boundaries", "name", b"name", "stats", b"stats"]) -> None: ...

    ZONES_FIELD_NUMBER: builtins.int
    @property
    def zones(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___MeshMetadata.Zone]:
        """Per-zone metadata."""
    def __init__(
        self,
        *,
        zones: collections.abc.Iterable[global___MeshMetadata.Zone] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["zones", b"zones"]) -> None: ...

global___MeshMetadata = MeshMetadata

class ListMeshesRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROJECT_ID_FIELD_NUMBER: builtins.int
    project_id: builtins.str
    """Required. The project to list meshes for."""
    def __init__(
        self,
        *,
        project_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["project_id", b"project_id"]) -> None: ...

global___ListMeshesRequest = ListMeshesRequest

class ListMeshesResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MESHES_FIELD_NUMBER: builtins.int
    @property
    def meshes(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Mesh]:
        """The list of meshes belonging to the specified project. Order of meshes is
        unspecified.
        """
    def __init__(
        self,
        *,
        meshes: collections.abc.Iterable[global___Mesh] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["meshes", b"meshes"]) -> None: ...

global___ListMeshesResponse = ListMeshesResponse

class UpdateMeshRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    id: builtins.str
    """Required. Identifies the mesh to update."""
    name: builtins.str
    """Required. Updated mesh name does not need to be unique. Maximum allowed
    length is 256 characters.
    """
    def __init__(
        self,
        *,
        id: builtins.str = ...,
        name: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["id", b"id", "name", b"name"]) -> None: ...

global___UpdateMeshRequest = UpdateMeshRequest

class UpdateMeshResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MESH_FIELD_NUMBER: builtins.int
    @property
    def mesh(self) -> global___Mesh:
        """The newly updated mesh."""
    def __init__(
        self,
        *,
        mesh: global___Mesh | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["mesh", b"mesh"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["mesh", b"mesh"]) -> None: ...

global___UpdateMeshResponse = UpdateMeshResponse

class CreateMeshRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class MeshAdaptationParams(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        SOURCE_SIMULATION_ID_FIELD_NUMBER: builtins.int
        TARGET_CV_COUNT_FIELD_NUMBER: builtins.int
        H_RATIO_FIELD_NUMBER: builtins.int
        source_simulation_id: builtins.str
        """Required. The simluation ID of a previously completed simulation. The
        source simulation will be used to extract the input mesh and mesh
        adaptation sensor from the solution.
        """
        target_cv_count: builtins.int
        """Required. Target count of mesh CVs."""
        h_ratio: builtins.float
        """Required. Boundary layer scaling. NOTE: will likely be removed before
        this API is release.
        """
        def __init__(
            self,
            *,
            source_simulation_id: builtins.str = ...,
            target_cv_count: builtins.int = ...,
            h_ratio: builtins.float = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing_extensions.Literal["h_ratio", b"h_ratio", "source_simulation_id", b"source_simulation_id", "target_cv_count", b"target_cv_count"]) -> None: ...

    PROJECT_ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    MESH_ADAPTATION_PARAMS_FIELD_NUMBER: builtins.int
    project_id: builtins.str
    """Required. The project that the mesh should be created in."""
    name: builtins.str
    """Optional. User specified mesh name, does not need to be unique. Maximum
    allowed length is 256 characters.
    """
    @property
    def mesh_adaptation_params(self) -> global___CreateMeshRequest.MeshAdaptationParams: ...
    def __init__(
        self,
        *,
        project_id: builtins.str = ...,
        name: builtins.str = ...,
        mesh_adaptation_params: global___CreateMeshRequest.MeshAdaptationParams | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["mesh_adaptation_params", b"mesh_adaptation_params", "params", b"params"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["mesh_adaptation_params", b"mesh_adaptation_params", "name", b"name", "params", b"params", "project_id", b"project_id"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["params", b"params"]) -> typing_extensions.Literal["mesh_adaptation_params"] | None: ...

global___CreateMeshRequest = CreateMeshRequest

class CreateMeshResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MESH_FIELD_NUMBER: builtins.int
    @property
    def mesh(self) -> global___Mesh:
        """The newly created mesh."""
    def __init__(
        self,
        *,
        mesh: global___Mesh | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["mesh", b"mesh"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["mesh", b"mesh"]) -> None: ...

global___CreateMeshResponse = CreateMeshResponse

class UploadMeshRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROJECT_ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    SCALING_FIELD_NUMBER: builtins.int
    UPLOAD_TOKEN_FIELD_NUMBER: builtins.int
    FILE_CHUNK_FIELD_NUMBER: builtins.int
    MESH_TYPE_FIELD_NUMBER: builtins.int
    DO_NOT_READ_ZONES_OPENFOAM_FIELD_NUMBER: builtins.int
    project_id: builtins.str
    """Required. The project that the mesh should be uploaded to."""
    name: builtins.str
    """Optional. User specified mesh name, does not need to be unique. Maximum
    allowed length is 256 characters.
    """
    scaling: builtins.float
    """Optional. Apply a scaling factor to the mesh. If unset, default is 1.0."""
    upload_token: builtins.str
    """For the first chunk, upload_token should be unset.
    For subsequent chunks, upload_token is required to be set to the
    upload_token value from the preceding UploadMeshResponse.
    """
    @property
    def file_chunk(self) -> luminarycloud._proto.api.v0.luminarycloud.common.common_pb2.FileChunk:
        """Required. The current data chunk to be upload. file_chunk.metadata will be
        constant across requests for a single mesh upload, but file_chunk.bytes
        should be updated for each chunk.
        """
    mesh_type: luminarycloud._proto.upload.upload_pb2.MeshType.ValueType
    """Required. The type of mesh being uploaded, e.g. CGNS, ANSYS."""
    do_not_read_zones_openfoam: builtins.bool
    """Optional. Set to disable reading cell zones in the polyMesh/cellZones file
    from OpenFOAM. Default false.
    """
    def __init__(
        self,
        *,
        project_id: builtins.str = ...,
        name: builtins.str = ...,
        scaling: builtins.float = ...,
        upload_token: builtins.str = ...,
        file_chunk: luminarycloud._proto.api.v0.luminarycloud.common.common_pb2.FileChunk | None = ...,
        mesh_type: luminarycloud._proto.upload.upload_pb2.MeshType.ValueType = ...,
        do_not_read_zones_openfoam: builtins.bool = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["file_chunk", b"file_chunk"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["do_not_read_zones_openfoam", b"do_not_read_zones_openfoam", "file_chunk", b"file_chunk", "mesh_type", b"mesh_type", "name", b"name", "project_id", b"project_id", "scaling", b"scaling", "upload_token", b"upload_token"]) -> None: ...

global___UploadMeshRequest = UploadMeshRequest

class UploadMeshResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MESH_FIELD_NUMBER: builtins.int
    UPLOAD_TOKEN_FIELD_NUMBER: builtins.int
    @property
    def mesh(self) -> global___Mesh:
        """The newly uploaded mesh."""
    upload_token: builtins.str
    """The upload_token value is used to group chunks of data belonging to the
    same mesh. It should be passed unmodified in the UploadMeshRequest to
    upload subsequent chunks. If upload_token is empty, it means the server
    considers the mesh upload to be completed and does not expect any more
    chunks to be sent.
    """
    def __init__(
        self,
        *,
        mesh: global___Mesh | None = ...,
        upload_token: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["mesh", b"mesh"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["mesh", b"mesh", "upload_token", b"upload_token"]) -> None: ...

global___UploadMeshResponse = UploadMeshResponse

class DeleteMeshRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    id: builtins.str
    """Required. Identifies the mesh to delete."""
    def __init__(
        self,
        *,
        id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["id", b"id"]) -> None: ...

global___DeleteMeshRequest = DeleteMeshRequest
